'''
Created on 03.04.2011
@author: achim brand
'''

from tools import DTTMTimeToDateTime, LittleToBig_2Bytes, LittleToBig_4Bytes


# print data from DopBase
def printDopBaseData(name, offset, value):
    print 'Name: \t\t', name
    if (name.find('Date') >= 0) and (value == 0):
        print 'Value: \t\tNever'
    elif name.find('Date') >= 0:
        print 'Value: \t\t', value, '(UTC)'
    else:
        print 'Value: \t\t', value
    print 'Offset: \t', offset
    print '----------------------------------------------------'
    pass


# read data from DopBase
def GetDopBaseData(DopBaseOffset, file):
    # define offsets to metadata
    dttmCreatedOffset = DopBaseOffset + 20
    dttmRevisedOffset = dttmCreatedOffset + 4
    dttmLastPrintOffset = dttmRevisedOffset + 4
    nRevisionOffset = dttmLastPrintOffset + 4
    tmEditedOffset = nRevisionOffset + 2
    cWordsOffset = tmEditedOffset + 4
    cChOffset = cWordsOffset + 4
    cPgOffset = cChOffset + 4
    cParasOffset = cPgOffset + 2
    print '----------------------------------------------------'
    print 'DopBase Metadata:'
    print '----------------------------------------------------'
    
    file.seek(dttmCreatedOffset,0); dttmCreated = file.read(4)
    printDopBaseData('Creation Date', dttmCreatedOffset, DTTMTimeToDateTime(dttmCreated))
    dttmRevised = file.read(4) 
    printDopBaseData('Last Save Date', dttmRevisedOffset, DTTMTimeToDateTime(dttmRevised))
    dttmLastPrint = file.read(4); printDopBaseData\
    ('Last Printed Date', dttmLastPrintOffset, DTTMTimeToDateTime(dttmLastPrint))
    nRevision = int(LittleToBig_2Bytes(file.read(2)),16)
    printDopBaseData('Revision Number', nRevisionOffset, nRevision)
    tmEdited = int(LittleToBig_4Bytes(file.read(4)),16)
    printDopBaseData('Editing Time', tmEditedOffset, tmEdited)
    cWords = int(LittleToBig_4Bytes(file.read(4)),16)
    printDopBaseData('Word Count', cWordsOffset, cWords)
    cCh = int(LittleToBig_4Bytes(file.read(4)),16)
    printDopBaseData('Character Count', cChOffset, cCh)
    cPg = int(LittleToBig_2Bytes(file.read(2)),16)
    printDopBaseData('Page Count', cPgOffset, cPg)
    cParas = int(LittleToBig_4Bytes(file.read(4)),16)
    printDopBaseData('Paragraph Count', cParasOffset, cParas)
    
    print 'End of DopBase Metadata.'
    print '----------------------------------------------------'
    pass


	